<?php
/*
 Simple:Press
 Admin Bar Plugin Support Routines
 */

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_admin_bar_do_new_post_list($newpostlist) {
         global $spThisUser;

         if (empty($newpostlist)) {
                 unset($newpostlist);
                 $newpostlist = array();
                 $newpostlist['topics'] = array();
                 $newpostlist['forums'] = array();
         }

         # Add waiting if admin or moderator (->moderator covers both)
        if ($spThisUser->moderator && $spThisUser->sfadminbar) {
                 $records = spdb_select('set', "SELECT DISTINCT topic_id, forum_id FROM ".SFWAITING, ARRAY_A);
                 if ($records) {
                         foreach ($records as $r) {
                                 if (sp_get_auth('view_forum', $r['forum_id']) && !in_array($r['topic_id'], $newpostlist['topics'])) {
                                         $newpostlist['topics'][] = $r['topic_id'];
                                         $newpostlist['forums'][] = $r['forum_id'];
                                 }
                         }
                 }
         }

         return $newpostlist;
}

function sp_admin_bar_do_deactivate() {
     # remove our auto update stuff
    $up = sp_get_sfmeta('autoupdate', 'admin');
     if ($up) sp_delete_sfmeta($up[0]['meta_id']);
}

function sp_admin_bar_uninstall_option_links($actionlink, $plugin) {
         if ($plugin == 'admin-bar/sp-admin-bar-plugin.php') {
         $url = SFADMINPLUGINS.'&action=uninstall&amp;plugin='.$plugin.'&amp;sfnonce='.wp_create_nonce('forum-adminform_plugins');
         $actionlink.= "&nbsp;&nbsp;<a href='$url' title='".__('Uninstall this plugin', 'spwo')."'>".__('Uninstall', 'spab').'</a>';
         $url = SFADMINADMIN.'&tab=globaladmin';
         $actionlink.= "&nbsp;&nbsp;<a href='$url' title='".__('Options', 'spab')."'>".__('Options', 'spab').'</a>';
     }
         return $actionlink;
}

function sp_admin_bar_do_load_js($footer) {
         global $sfvars, $spThisUser;

     if (!$spThisUser->moderator) return;

     # always load the auto update scripts if needed
        $sfauto = sp_get_option('sfauto');
         if ($sfauto['sfautoupdate']) wp_enqueue_script('spabupdate', SPABSCRIPT.'sp-admin-bar-update.js', array('jquery'), false, $footer);

     $script = (defined('SP_SCRIPTS_DEBUG') && SP_SCRIPTS_DEBUG) ? SPABSCRIPT.'sp-admin-bar-dev.js' : SPABSCRIPT.'sp-admin-bar.js';
         wp_enqueue_script('spabjs', $script, array('jquery'), false, $footer);

         $strings = array(
                 'loading'       => __('Loading topic', 'spab'),
                 'saving'        => __('Saving post', 'spab'),
         );
     wp_localize_script('spabjs', 'sp_adminbar_vars', $strings);
}

function sp_admin_bar_do_header() {
         global $spThisUser;

     if (!$spThisUser->moderator) return;

         # check for css in current theme first
        $css = sp_find_css(SPABCSS, 'sp-admin-bar.css');
         echo "<link rel='stylesheet' type='text/css' href='$css' />\n";
}

function sp_AdminBarGetWaiting() {
         global $spThisUser;

         # set up new posts
        if (($spThisUser->admin || $spThisUser->moderator)) {
                 global $spNewPosts, $sfvars;
             include_once(SPABLIBDIR.'sp-admin-bar-components.php');
                 $spNewPosts = sp_GetAdminsQueuedPosts();

                 # check if the queue is up to 200 posts whi is dangerous - output message
                if (isset($sfvars['queue']) && $sfvars['queue'] > 199) {
                         $out = '<div class="spMessage">';
                         $out.= '<p>'.sprintf(__('WARNING: The admin postbag contains %s posts which require removal', 'spab'), $sfvars['queue']).'</p>';
                         $out.= '</div>';
                         $out = apply_filters('sph_AdminQueueWarning', $out);
                         echo $out;
                 }
         }
}

function sp_GetAdminsQueuedPosts() {
         global $sfvars;

         $newposts = '';
         $clause = '';

         $records = spdb_select('set',
                         'SELECT '.SFWAITING.'.forum_id, forum_slug, forum_name, forum_icon, topic_id, '.SFWAITING.'.post_count, '.SFWAITING.'.post_id
                          FROM '.SFWAITING.'
                          LEFT JOIN '.SFFORUMS.' ON '.SFWAITING.'.forum_id = '.SFFORUMS.'.forum_id
                          ORDER BY forum_id');

         if ($records) {
                 # now grab all of the post record we are going to need in one query
                $pcount = count($records);
                 $done = 0;

                 foreach ($records as $record) {
                         $clause.= '('.SFTOPICS.'.topic_id = '.$record->topic_id.' AND '.SFPOSTS.'.post_id >= '.$record->post_id.')';
                         $done++;
                         if ($done < $pcount) $clause.= ' OR ';
                 }

                 $preparedpostrecords = spdb_select('set',
                                 'SELECT '.SFPOSTS.'.topic_id, post_content, post_index, '.SFPOSTS.'.post_id, post_status, '.SFPOSTS.'.user_id, '.SFMEMBERS.'.display_name, guest_name, topic_slug, topic_name
                                  FROM '.SFPOSTS.'
                                  LEFT JOIN '.SFTOPICS.' ON '.SFPOSTS.'.topic_id = '.SFTOPICS.'.topic_id
                                  LEFT JOIN '.SFMEMBERS.' ON '.SFPOSTS.'.user_id = '.SFMEMBERS.".user_id
                                  WHERE $clause
                                  AND (admin = 0 OR admin IS NULL) AND (moderator = 0 OR moderator IS NULL)
                                  ORDER BY post_id");

                 $sfvars['queue'] = count($preparedpostrecords);

                 $newposts = array();
                 $findex=-1;
                 $pindex=0;
                 $tindex=0;

                 foreach ($records as $record) {
                         # Check this still has posts in it and they were not removed (it happens)
                        $postrecords='';
                         foreach ($preparedpostrecords as $prepared) {
                                 if ($prepared->topic_id == $record->topic_id) {
                                         $postrecords[] = $prepared;
                                 }
                         }
                         # So - were they removed? if so donlt add them to the array and remove them from sfwaiting
                        if ($postrecords == '') {
                                 sp_remove_from_waiting(true, $record->topic_id, $record->post_id);
                                 continue;
                         }

                         $forumid=$record->forum_id;
                         if($findex == -1 || $newposts[$findex]['forum_id'] != $forumid) {
                                 $findex++;
                                 $tindex=0;
                                 $pindex=0;
                                 $newposts[$findex]['forum_id'] = $record->forum_id;
                                 $newposts[$findex]['forum_name'] = $record->forum_name;
                                 $newposts[$findex]['forum_slug'] = $record->forum_slug;
                                 $newposts[$findex]['forum_icon'] = $record->forum_icon;
                         }

                         $newposts[$findex]['topics'][$tindex]['topic_id'] = $record->topic_id;
                         $newposts[$findex]['topics'][$tindex]['post_id'] = $record->post_id;

                         # isolate the post records for current topic
                        $postrecords='';
                         foreach ($preparedpostrecords as $prepared) {
                                 if($prepared->topic_id == $record->topic_id) {
                                         $postrecords[] = $prepared;
                                 }
                         }

                         if ($postrecords) {
                                 $newposts[$findex]['topics'][$tindex]['post_count'] = count($postrecords);
                                 $pindex = 0;
                                 foreach($postrecords as $postrecord) {
                                         $newposts[$findex]['topics'][$tindex]['topic_slug'] = $postrecord->topic_slug;
                                         $newposts[$findex]['topics'][$tindex]['topic_name'] = $postrecord->topic_name;

                                         $newposts[$findex]['topics'][$tindex]['posts'][$pindex]['post_id'] = $postrecord->post_id;
                                         $newposts[$findex]['topics'][$tindex]['posts'][$pindex]['post_status'] = $postrecord->post_status;
                                         $newposts[$findex]['topics'][$tindex]['posts'][$pindex]['post_index'] = $postrecord->post_index;
                                         $newposts[$findex]['topics'][$tindex]['posts'][$pindex]['post_content'] = $postrecord->post_content;
                                         $newposts[$findex]['topics'][$tindex]['posts'][$pindex]['user_id'] = $postrecord->user_id;
                                         if(empty($postrecord->user_id)) {
                                                 $newposts[$findex]['topics'][$tindex]['posts'][$pindex]['display_name'] = $postrecord->guest_name;
                                                 $thisuser = 'Guest';
                                         } else {
                                                 $newposts[$findex]['topics'][$tindex]['posts'][$pindex]['display_name'] = $postrecord->display_name;
                                                 $thisuser = 'Member';
                                         }
                                         $newposts[$findex]['topics'][$tindex]['posts'][$pindex]['user_type'] = $thisuser;
                                         $pindex++;
                                 }
                         }
                         $tindex++;
                 }
         }

         # if no new posts then housekeep sfwaiting
        if (!$newposts) spdb_query('TRUNCATE '.SFWAITING);

         return $newposts;
}

# ------------------------------------------------------------------
# sp_GetWaitingUrl()
#
# Creates the new post urls and counts in the Admin Bar
#       $postlist:              array from the admin queue of posts
# ------------------------------------------------------------------
function sp_GetWaitingUrl($postlist) {
         global $sfvars, $spThisUser;

         # check if topic in url - if yes and it is in postlist - remove it.
        $newposts = array();
         $index = 0;
         $modcount = 0;
         $readcount = 0;
         $spamcount = 0;
         if ($postlist) {
                 if (!empty($sfvars['topicid'])) {
                         $topicid=$sfvars['topicid'];
                         foreach ($postlist as $forum) {
                                 if (isset($forum['topics'])) {
                                         foreach ($forum['topics'] as $topic) {
                                                 if (isset($topic['posts'])) {
                                                         foreach ($topic['posts'] as $post) {
                                                                 $readcount++;
                                                                 if (!isset($post['topic_id']) || $post['topic_id'] != $topicid) {
                                                                         $newposts[$index]->post_id=$post['post_id'];
                                                                         # increment mod count for this user
                                                                        if ($post['post_status'] == 1) $modcount++;
                                                                         if ($post['post_status'] == 2) $spamcount++;
                                                                         $index++;
                                                                 } else {
                                                                         if ($post['post_status'] != 0) {
                                                                                 if ($post['post_status'] == 1) $modcount++;
                                                                                 $newposts[$index]->post_id = $post['post_id'];
                                                                                 if ($post['post_status'] == 2) $spamcount++;
                                                                                 $index++;
                                                                         }
                                                                 }
                                                         }
                                                 }
                                         }
                                 }
                         }
                 } else {
                         $newposts = $postlist;
                         foreach ($postlist as $forum) {
                                 if (isset($forum['topics'])) {
                                         foreach ($forum['topics'] as $topic) {
                                                 if (isset($topic['posts'])) {
                                                         foreach ($topic['posts'] as $post) {
                                                                 $readcount++;
                                                                 # increment mod count for this user
                                                                if ($post['post_status'] == 1) $modcount++;
                                                                 if ($post['post_status'] == 2) $spamcount++;
                                                         }
                                                 }
                                         }
                                 }
                         }
                 }
         }
         if ($newposts) {
                 $readcount = $readcount - ($modcount+$spamcount);
         } else {
                 $readcount = 0;
                 $modcount = 0;
                 $spamcount = 0;
         }

         $site = SFHOMEURL.'index.php?sp_ahah=admin-bar-newposts&amp;sfnonce='.wp_create_nonce('forum-ahah');
         $numbersurl = SFHOMEURL.'index.php?sp_ahah=admin-bar-update&amp;sfnonce='.wp_create_nonce('forum-ahah');

         $href = 'javascript:void(0)';
         $jscall = ' onclick="spabGetNewPostList(\''.$site.'\', \''.$numbersurl.'\')"';

         # All posts
        $out = '<a rel="nofollow" class="spLeft spButton vtip" title="'.esc_attr(__('Open/Close the admin postbag', 'spab')).'" href="'.$href.'" '.$jscall.'>';
         $out.= '<img class="spImg" src="'.sp_find_icon(SPABIMAGES, "sp_AdminQueue.png").'" alt="" />'.__('View New Posts', 'spab');
         $out.= '</a>';

         # Ordinary Posts
        $out.= '<div class="spLeft spButtonAsLabel">';
     $adminClass = ($readcount > 0) ? 'spUnreadUnread' : 'spUnreadRead';
         $out.= __('Unread', 'spab').": <span id='spUnread'><span class='$adminClass'>$readcount </span></span>";
         $out.= '</div>';

         $out.= '<div class="spLeft spButtonAsLabel">';
     $adminClass = ($modcount > 0) ? 'spModUnread' : 'spModRead';
         $out.= __('Need Moderation', 'spab').": <span id='spNeedModeration'><span class='$adminClass'>$modcount </span></span>";
         $out.= '</div>';

         $out.= '<div class="spLeft spButtonAsLabel">';
     $adminClass = ($spamcount > 0) ? 'spSpamUnread' : 'spSpamRead';
         $out.= __('Spam', 'spab').": <span id='spSpam'><span class='$adminClass'>$spamcount </span></span>";
         $out.= '</div>';

         return $out;
}

function sp_NewPostListAdmin($newposts) {
         global $sfvars, $spThisUser, $sfglobals;

         $alt = '';
         $nourl = '';

         if ($newposts) {
                 $index = array();
                 foreach ($newposts as $newpost) {
                         $forumid = $newpost['forum_id'];
                         $index[$forumid] = count($newpost['topics']);
                 }

                 # Set up the autoupdate url (for quicklinks refreshing)
        $updateUrl = SFHOMEURL.'index.php?sp_ahah=autoupdate&amp;sfnonce='.wp_create_nonce('forum-ahah');

                 # Display section heading
                echo '<div class="spAdminQueueHeader">';
                 echo '<a id="newpoststop"></a>';

                 $options = sp_get_option('spAdminBar');
                 if ($spThisUser->admin || $spThisUser->moderator) {
                         echo '<form class="sfsubhead" action="'.sp_url().'" method="post" name="removequeue">';
                         echo '<input type="hidden" name="doqueue" value="1" />';
                         echo '<p>'.__('New/Unread Posts - Management View', 'spab');
                         echo '&nbsp;&nbsp;<a class="spButton spRight" href="javascript:document.removequeue.submit();"><img src="'.sp_find_icon(SPABIMAGES, "sp_markRead.png").'" alt="" />'.__('Empty the Admin postbag', 'spab').'</a></p>';
                         echo '</form>';
                         $removal = true;
                         $canremove = '1';
                 }
                 echo '</div>';

                 # Start actual listing display
                echo '<div class="spInlineSection spMessageSuccess" id="spAdminQueueMsg"></div>';

                 # Display new posts heading
                sp_SectionStart('tagClass=spAdminQueueSection', 'AdminQueue');
                 echo '<p align="center" class="spAdminBarTitle">'.__('Forums and Topics', 'spab').'</p>';

                 # Start with main forum header
                foreach ($newposts as $newpost) {
                         # Display forum name
                        echo '<div id="spAdminQueueForum'.$newpost['forum_id'].'" class="spAdminQueueForum">';
                                 sp_ColumnStart('tagClass=spColumnSection spLeft&height=30px&width=9%');
                         $icon = (!empty($newpost['forum_icon'])) ? SFCUSTOMURL.$newpost['forum_icon'] : SPTHEMEICONSURL.'sp_ForumIcon.png';
                                         echo '<img class="spRowIcon" src="'.$icon.'" alt="" />';
                                 sp_ColumnEnd();

                                 sp_ColumnStart('tagClass=spColumnSection spLeft&height=30px&width=90%');
                                         echo '<p class="spAdminForum">';
                                         echo '<a class="spRowName" href="'.sp_build_url($newpost['forum_slug'], '', 1, 0).'">Forum: '.$newpost['forum_name'].'</a>';
                                         echo '</p>';
                                         echo '<input type="hidden" id="tcount'.$newpost['forum_id'].'" value="'.$index[$newpost['forum_id']].'" />';
                                 sp_ColumnEnd();
                         echo '<div class="spClear"></div>';
                         echo '</div>';

                         # Now for each topic with new posts
                        foreach ($newpost['topics'] as $topic) {
                                 $postcountmod = 0;
                                 $postcountord = 0;

                                 # a quick first pass to load the post count variables and check for spam
                                $is_spam = false;
                                 foreach ($topic['posts'] as $post) {
                                         if ($post['post_status'] != 0 ? $postcountmod++ : $postcountord++);
                                         if ($post['post_status'] == 2) $is_spam=true;
                                         $lastpost_id = $post['post_id'];
                                 }

                                 # Display topics in forum
                                $class = ($postcountmod) ? 'spSubmit spModButton' : 'spSubmit spUnreadButton';

                                 echo '<div id="spAdminQueueTopic'.$topic['topic_id'].'" class="spAdminQueueTopic">';
                                         sp_ColumnStart('tagClass=spColumnSection spLeft&height=30px&width=10%');
                                                 echo "<input type='button' name='openicon".$topic['topic_id']."' class='".$class."' value='";
                                                 echo esc_attr(__('View', 'spab'));
                                                 if ($is_spam) {
                                                         echo "\n".esc_attr(__('Spam', 'spab'));
                                                 }
                                                 echo "' onclick='spjToggleLayer(\"spAdminQueueThisTopic".$topic['topic_id']."\");' />";
                                                 echo '<input type="hidden" id="pcount'.$topic['topic_id'].'" value="'.$topic['post_count'].'" />';
                                                 echo '<input type="hidden" id="pcountmod'.$topic['topic_id'].'" value="'.$postcountmod.'" />';
                                                 echo '<input type="hidden" id="pcountord'.$topic['topic_id'].'" value="'.$postcountord.'" />';
                                         sp_ColumnEnd();

                                         sp_ColumnStart('tagClass=spColumnSection spLeft&height=30px&width=90%');
                                                 echo '<p>'.sp_get_topic_newpost_url($newpost['forum_slug'], $topic['topic_slug'], $topic['topic_name'], $lastpost_id, $post['post_index']).'</p>';
                                                 $nourl = '';
                                                 if ($topic['post_count'] == 1) {
                                                         $note = __('There is 1 new post in this topic', 'spab');
                                                 } else {
                                                         $note = sprintf(__('There are %s new posts in this topic', 'spab'), $topic['post_count']);
                                                 }
                                                 echo '<p class="spLabelSmall">'.$note.'</p>';
                                         sp_ColumnEnd();
                                 echo '<div class="spClear"></div>';
                                 echo '</div>';

                                 # Start display of post information
                                echo '<div id="spAdminQueuePost'.$topic['topic_id'].'" class="spAdminQueuePost">';
                                         echo '<div id="spAdminQueueThisTopic'.$topic['topic_id'].'" class="spPostSection spInlineSection">';
                                                 echo '<p align="center" class="spAdminBarTitle">'.__('Post Details', 'spab').'</p>';
                                                 $pindex = 0;
                                                 $mod_required = false;

                                                 # Start the post display loop
                                                foreach ($topic['posts'] as $post) {
                                                         $is_spam = false;
                                                         if ($pindex > 0) echo '<hr>';
                                                         echo '<div id="spAdminQueueThisPost'.$post['post_id'].'" class="spAdminQueueThisPost">';
                                                         $pindex++;
                                                         $lastpost = ($pindex == $topic['post_count']) ? true : false;
                                                         if ($post['post_status'] != 0) {
                                                                 $mod_required = true;
                                                                 echo '<div class="spAdminQueueMod spRight">'.__('Awaiting moderation', 'spab');
                                                                 if($post['post_status']==2) {
                                                                         $is_spam = true;
                                                                         echo '<br />'.__('Akismet marked as spam', 'spab');
                                                                 }
                                                                 echo '</div>';
                                                         }
                                                         echo '<b>'.sp_filter_name_display($post['display_name']).'</b><br /><small>'.$post['user_type'].'</small>';
                                                         echo '<br /><small>'.sprintf(__('Post %s in Topic', 'spab'), $post['post_index']).'</small>';
                                                         echo '<hr />'.sp_filter_content_display($post['post_content']).'</td>';
                                                         echo '</div>';

                                                         # Set up the ahah base url
                                    $basesite = SFHOMEURL."index.php?sp_ahah=moderation&amp;sfnonce=".wp_create_nonce('forum-ahah')."&amp;pid=".$post['post_id']."&amp;tid=".$topic['topic_id']."&amp;fid=".$newpost['forum_id'];

                                                         echo '<div id="spAdminQueueThisPostButtons'.$post['post_id'].'">';
                                                                 if ($topic['post_count'] == 1) {
                                                                         $label = __('This Post', 'spab');
                                                                 } else {
                                                                         $label = __('All Posts', 'spab');
                                                                 }

                                                                 if ($lastpost) {
                                                                         $site = $basesite.'&amp;action=0&amp;canremove='.$canremove;

                                                                         if ($mod_required) {
                                                                                 if (sp_get_auth('moderate_posts', $newpost['forumid'])) {
                                                                                         $posturl = sp_build_url($newpost['forum_slug'], $topic['topic_slug'], 0, $post['post_id'], $post['post_index']);
                                                                                         $posturl = sp_get_sfqurl($posturl);
                                                                                         $posturl .= 'mod=1/#'.$post['post_id'];
                                                                                 }
                                                                         } else {
                                                                                 $posturl = sp_build_url($newpost['forum_slug'], $topic['topic_slug'], 0, $post['post_id'], $post['post_index']);
                                                                                 $posturl = sp_get_sfqurl($posturl);
                                                                                 $posturl.= 'mark=1/#'.$post['post_id'];
                                                                         }

                                                                         if ($mod_required) {
                                                                                 echo '<input type="button" class="spSubmit" name="g0-'.$post['post_id'].'" value="'.sp_split_button_label(esc_attr(sprintf(__("Mark %s Approved and go to Topic", 'spab'), $label)), 2).'" onclick="spabModeratePost(\''.$posturl.'\', \''.$site.'\', \''.$removal.'\', \''.$post['post_id'].'\', \''.$newpost['forum_id'].'\', \''.$topic['topic_id'].'\', \''.$post['post_status'].'\', \'9\', \''.$updateUrl.'\');" />';
                                                                                 echo '<input type="button" class="spSubmit" name="a0-'.$post['post_id'].'" value="'.sp_split_button_label(esc_attr(sprintf(__("Mark %s Approved and Close", 'spab'), $label)), 2).'" onclick="spabModeratePost(\''.$nourl.'\', \''.$site.'\', \''.$removal.'\', \''.$post['post_id'].'\', \''.$newpost['forum_id'].'\', \''.$topic['topic_id'].'\', \''.$post['post_status'].'\', \'0\', \''.$updateUrl.'\');" />';
                                                                                 echo '<input type="button" class="spSubmit" name="q0-'.$post['post_id'].'" value="'.sp_split_button_label(esc_attr(sprintf(__("Mark %s Approved and Quick Reply", 'spab'), $label)), 2).'" onclick="spjToggleLayer(\'sfqform'.$topic['topic_id'].'\');" />';
                                                                                 $qaction = 0;
                                                                         } else {
                                                                                 $site = $basesite.'&amp;action=1&amp;canremove='.$canremove;
                                                                                 echo '<input type="button" class="spSubmit" name="g1-'.$post['post_id'].'" value="'.sp_split_button_label(esc_attr(sprintf(__("Mark %s as Read and go to Topic", 'spab'), $label)), 2).'" onclick="spabModeratePost(\''.$posturl.'\', \''.$site.'\', \''.$removal.'\', \''.$post['post_id'].'\', \''.$newpost['forum_id'].'\', \''.$topic['topic_id'].'\', \''.$post['post_status'].'\', \'1\', \''.$updateUrl.'\');" />';
                                                                                 echo '<input type="button" class="spSubmit" name="a1-'.$post['post_id'].'" value="'.sp_split_button_label(esc_attr(sprintf(__("Mark %s as Read and Close", 'spab'), $label)), 2).'" onclick="spabModeratePost(\''.$nourl.'\', \''.$site.'\', \''.$removal.'\', \''.$post['post_id'].'\', \''.$newpost['forum_id'].'\', \''.$topic['topic_id'].'\', \''.$post['post_status'].'\', \'1\', \''.$updateUrl.'\');" />';
                                                                                 echo '<input type="button" class="spSubmit" name="a1-'.$post['post_id'].'" value="'.sp_split_button_label(esc_attr(sprintf(__("Mark %s as Read and Quick Reply", 'spab'), $label)), 2).'" onclick="spjToggleLayer(\'sfqform'.$topic['topic_id'].'\');" />';
                                                                                 $qaction = 1;
                                                                         }
                                                                 }

                                                                 if ($removal) {
                                                                         $remsite = $basesite.'&amp;action=2&amp;canremove='.$canremove;
                                                                         $msg = esc_js(__('Are you sure you want to delete this Post?', 'spab'));
                                                                         echo '<input type="button" class="spSubmit" name="a2-'.$post['post_id'].'" value="'.sp_split_button_label(esc_attr(__('Delete this Post', 'spab')), 0).'" onclick="javascript: if(confirm(\''.$msg.'\')) {spabModeratePost(\''.$nourl.'\', \''.$remsite.'\', \''.$removal.'\', \''.$post['post_id'].'\', \''.$newpost['forum_id'].'\', \''.$topic['topic_id'].'\', \''.$post['post_status'].'\', \'2\', \''.$updateUrl.'\');}" />';

                                                                         if ($post['user_type']=='Member' && $is_spam) {
                                                                                 $actionUrl = SFHOMEURL.'index.php?sp_ahah=remove-spam&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;postid='.$post['post_id'].'&amp;userid='.$post['user_id'];
                                                                                 $updateUrl = SFHOMEURL.'index.php?sp_ahah=admin-bar-update&amp;target=newposts&amp;sfnonce='.wp_create_nonce('forum-ahah');
                                                                                 echo '<input type="button" class="spSubmit" name="delSpam-'.$post['post_id'].'" value="'.sp_split_button_label(esc_attr(__("Remove this Member and All their Posts", 'spab')),2).'" onclick="spabRemoveSpam(\''.$actionUrl.'\', \''.$updateUrl.'\');" />';
                                                                         }
                                                                 }

                                                                 # Quick Reply Form
                                                                if ($lastpost) {
                                                 $qsavesite = SFHOMEURL."index.php?sp_ahah=quickreply&amp;sfnonce=".wp_create_nonce('forum-ahah')."&amp;tid=".$topic['topic_id']."&amp;fid=".$newpost['forum_id'];
                                                                         echo '<div id="sfqform'.$topic['topic_id'].'" class="spInlineSection">';
                                                                         echo '<form action="'.sp_url().'" method="post" name="addpost'.$topic['topic_id'].'" onsubmit="return spabSaveQuickReply(this, \''.$qsavesite.'\', \''.$site.'\', \''.$post['post_id'].'\', \''.$newpost['forum_id'].'\', \''.$topic['topic_id'].'\', \''.$post['post_status'].'\', \''.$qaction.'\', \''.$updateUrl.'\')">';
                                                                         echo '<textarea  tabindex="1" class="spControl" name="postitem'.$topic['topic_id'].'" id="postitem'.$topic['topic_id'].'" cols="60" rows="8"></textarea>';
                                                                         echo '<br /><input type="submit" tabindex="2" class="spSubmit" id="sfsave'.$topic['topic_id'].'" name="newpost'.$topic['topic_id'].'" value="'.esc_attr(__('Save New Post', 'spab')).'" />';

                                                                         do_action('sph_quickreply_form', $newtopic, $topic, $post);

                                                                         echo '</form><br /></div>';
                                                                 }
                                                         echo '</div>';
                                                 }
                                         echo '</div>';
                                 echo '</div>';
                         }
                 }
                 sp_SectionEnd('', 'AdminQueue');
         } else {
                 echo '<div class="spMessage">';
                 echo __('There are no unread posts', 'spab').'</div>';
                 echo "<div class='spInlineSection' id='spAdminQueueMsg'></div>\n";
         }
}

function sp_AdminBarDashboardPosts() {
         global $spThisUser;
         $out = '';

         # New/Unread Admin Post List
        $options = sp_get_option('spAdminBar');
         if ($options['dashboardposts']) {
         if ($spThisUser->admin) {
                         $waiting = spdb_count(SFPOSTS, 'post_status != 0');
                 $unreads = sp_AdminBarGetUnreadForums();
                 $out.= '<p>'.__('The Admin postbag', 'spab').'</p>';
         } else {
             $waiting = 0;
                 $unreads = '';
             if ($spThisUser->newposts) {
                 foreach ($spThisUser->newposts['forums'] as $index => $forum) {
                     $unreads[$index]->forum_slug = spdb_table(SFFORUMS, 'forum_id='.$forum, 'forum_slug');
                     $topic = spdb_table(SFTOPICS, 'topic_id='.$spThisUser->newposts['topics'][$index]);
                     $unreads[$index]->topic_slug = $topic[0]->topic_slug;
                     $unreads[$index]->post_id = $topic[0]->post_id;
                 }
             }
                 $out.= '<p>'.__('Unread Posts', 'spab').'</p>';
         }

                 if ($unreads) {
                         $out.='<table class="sfdashtable">';
                         foreach ($unreads as $unread) {
                                 $out.= '<tr>';
                                 if ($unread->post_count == 1) {
                                         $mess = sprintf(__('There is %s new post', 'spb'), $unread->post_count);
                                 } else {
                                         $mess = sprintf(__('There are %s new posts', 'spab'), $unread->post_count);
                                 }
                                 $out.= '<td>'.$mess.' '.__('in the forum topic', 'spab').':&nbsp;&nbsp;'.sp_AdminBarDashboardUrl($unread->forum_slug, $unread->topic_id, $unread->post_id).'</td>';
                                 $out.= '</tr>';
                         }
                         $out.= '</table>';

                         if ($waiting == 1) $out.= '<br /><table class="sfdashtable"><tr><td>'.__('There is 1 post awaiting approval', 'spab').'</td></tr></table>';
                         if ($waiting > 1) $out.= '<br /><table class="sfdashtable"><tr><td>'.__('There are', 'spab').' '.$waiting.' '.__('posts awaiting approval', 'spab').'.</td></tr></table>';
                 } else {
                         $out.= '<p>'. __('There are no new forum posts', 'spab').'</p>';
                 }
         }
         echo $out;
}

# ------------------------------------------------------------------
# sp_AdminBarGetUnreadForums()
#
# Returns list from the waiting table (Admins queue) for dashboard
# ------------------------------------------------------------------
function sp_AdminBarGetUnreadForums() {
         return spdb_select('set',
                         'SELECT topic_id, '.SFWAITING.'.forum_id, forum_slug, forum_name, group_id, '.SFWAITING.'.post_count, '.SFWAITING.'.post_id
                          FROM '.SFFORUMS.'
                          JOIN '.SFWAITING.' ON '.SFFORUMS.'.forum_id = '.SFWAITING.'.forum_id
                          WHERE '.SFWAITING.'.post_count > 0
                          ORDER BY forum_id, topic_id');
}

function sp_AdminBarDashboardUrl($forumslug, $topicid, $postid) {
     $out = '';
     $topic = spdb_table(SFTOPICS, "topic_id='$topicid'");
     if (!empty($topic)) $out = '<a href="'.sp_build_url($forumslug, $topic[0]->topic_slug, 0, $postid).'"><img src="'. SFADMINIMAGES .'sp_AnnounceNew.png" alt="" />&nbsp;&nbsp;'.$topic[0]->topic_name.'</a>'."\n";
         return $out;
}

function sp_AdminBarEmail($msg, $newpost){
         $total = 0;
         $unread = spdb_table(SFWAITING);
         if ($unread) {
                 foreach ($unread as $entry) {
                         $total+= $entry->post_count;
                 }
         }

         $eol = "\r\n";
         $msg.= __('There are currently', 'spab').' '.$total.' '.__('post(s) in', 'spab').' '.count($unread).' '.__('topic(s) awaiting review', 'spab').$eol;
     return $msg;
}

# ------------------------------------------------------------------
# sp_get_topic_newpost_url()
#
# Builds the admin new post url
#       $forumslug:             forum slug
#       $topicslug:             topic slug
#       $topicname:             topic name
#       $postid:                if of post
#       $postindex:             index of post if known
# ------------------------------------------------------------------
function sp_get_topic_newpost_url($forumslug, $topicslug, $topicname, $postid, $postindex=0) {
         $out = '<a href="'.sp_build_url($forumslug, $topicslug, 0, $postid, $postindex).'">'.$topicname.'</a>'."\n";
         return $out;
}

?>
