<?php
/*
 Simple:Press Plugin Title: Admin Bar
 Version: 1.1
 Plugin URI: http://simple-press.com
 Description: The Admin Bar helps to manage the admininstrators postbag of new forum posts and posts awaiting moderation as well as add optional Akismet support to help identify and quickly deal with spam posts
 Author: Andy Staines & Steve Klasen
 Author URI: http://simple-press.com
 Simple:Press Versions: 5.1 and above
 */

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

define('SPABDIR',               SFPLUGINDIR.'admin-bar/');
define('SPABADMINDIR',  SFPLUGINDIR.'admin-bar/admin/');
define('SPABLIBDIR',    SFPLUGINDIR.'admin-bar/library/');
define('SPABTAGSDIR',   SFPLUGINDIR.'admin-bar/template-tags/');
define('SPABAHAHDIR',   SFPLUGINDIR.'admin-bar/ahah/');
define('SPABIMAGES',    SFPLUGINURL.'admin-bar/resources/images/');
define('SPABCSS',               SFPLUGINURL.'admin-bar/resources/css/');
define('SPABSCRIPT',    SFPLUGINURL.'admin-bar/resources/jscript/');

 add_action('init',                                                                                              'sp_admin_bar_localization');
 add_action('sph_activate_admin-bar/sp-admin-bar-plugin.php',    'sp_admin_bar_install');
 add_action('sph_uninstall_admin-bar/sp-admin-bar-plugin.php',   'sp_admin_bar_uninstall');
 add_action('sph_deactivate_admin-bar/sp-admin-bar-plugin.php',  'sp_admin_bar_deactivate');
 add_action('sph_admins_global_left_panel',                                              'sp_admin_bar_admin');
 add_action('sph_admin_global_options_save',                                             'sp_admin_bar_admin_save');
 add_action('sph_admins_global_right_panel',                                     'sp_akismet_admin_options');
 add_action('sph_admins_options_top_panel',                                              'sp_admin_bar_options');
 add_action('sph_admin_your_options_save',                                               'sp_admin_bar_options_save');
 add_filter('sph_acknowledgements',                                                              'sp_akismet_acknowledgement');
 add_action('sph_AfterDisplayStart',                                                             'sp_admin_bar_get_waiting');
 add_action('sph_ahah_handler_admin-bar-links',                                  'sp_admin_bar_ahah_links');
 add_action('sph_ahah_handler_admin-bar-update',                                 'sp_admin_bar_ahah_update');
 add_action('sph_ahah_handler_admin-bar-newposts',                               'sp_admin_bar_ahah_newposts');
 add_action('sph_ahah_handler_quickreply',                                               'sp_admin_bar_ahah_quickreply');
 add_action('sph_ahah_handler_remove-spam',                                              'sp_admin_bar_ahah_delspam');
 add_action('sph_ahah_handler_moderation',                                               'sp_admin_bar_ahah_moderation');
 add_action('sph_head_end',                                                                              'sp_admin_bar_header');
 add_action('sph_scripts_end',                                                                   'sp_admin_bar_load_js');
 add_action('sph_dashboard_start',                                                               'sp_admin_bar_dashboard');

 add_filter('sph_admin_help-admin-admins',       'sp_admin_bar_help', 10, 3);
 add_filter('sph_plugins_active_buttons',        'sp_admin_bar_uninstall_option', 10, 2);
 add_filter('sph_add_to_waiting',                        'sp_admin_bar_create_post');
 add_filter('sph_admin_email',                           'sp_admin_bar_email', 10, 2);
 add_filter('sph_new_forum_post',                        'sp_run_akismet');
 add_filter('sph_new_post_list',                         'sp_admin_bar_new_post_list');

function sp_admin_bar_admin() {
     include_once(SPABADMINDIR.'sp-admin-bar-admin.php');
         sp_admin_bar_admin_form();
}

function sp_admin_bar_admin_save() {
     include_once(SPABADMINDIR.'sp-admin-bar-admin-save.php');
         return sp_admin_bar_admin_options_save();
}

function sp_akismet_admin_options() {
         include_once(SPABADMINDIR.'sp-admin-bar-admin.php');
         sp_akismet_admin_options_form();
}

function sp_admin_bar_options() {
     include_once(SPABADMINDIR.'sp-admin-bar-options.php');
         sp_admin_bar_options_form();
}

function sp_admin_bar_options_save() {
     include_once(SPABADMINDIR.'sp-admin-bar-options-save.php');
         return sp_admin_bar_options_update();
}

function sp_admin_bar_help($file, $tag, $lang) {
     if ($tag == '[admin-bar]' || $tag == '[akismet]' || $tag == '[admin-bar-options]') $file = SPABADMINDIR.'sp-admin-bar-admin-help.'.$lang;
     return $file;
}

function sp_admin_bar_localization() {
         sp_plugin_localisation('spab');
}

function sp_admin_bar_install() {
     include_once(SPABDIR.'sp-admin-bar-install.php');
     sp_admin_bar_do_install();
}

function sp_admin_bar_uninstall() {
     include_once(SPABDIR.'sp-admin-bar-uninstall.php');
     sp_admin_bar_do_uninstall();
}

function sp_admin_bar_uninstall_option($actionlink, $plugin) {
     include_once(SPABLIBDIR.'sp-admin-bar-components.php');
     $actionlink = sp_admin_bar_uninstall_option_links($actionlink, $plugin);
         return $actionlink;
}

function sp_admin_bar_deactivate() {
     include_once(SPABLIBDIR.'sp-admin-bar-components.php');
     sp_admin_bar_do_deactivate();
}

function sp_akismet_acknowledgement($ack) {
         $ack[] = __('Akismet WordPress plugin by', 'sp-akismet').': <a href="http://automattic.com/wordpress-plugins/">Automattic</a>';
         return $ack;
}

function sp_admin_bar_header() {
     include_once(SPABLIBDIR.'sp-admin-bar-components.php');
     sp_admin_bar_do_header();
}

function sp_admin_bar_load_js($footer) {
     include_once(SPABLIBDIR.'sp-admin-bar-components.php');
     sp_admin_bar_do_load_js($footer);
}

function sp_admin_bar_get_waiting() {
     include_once(SPABLIBDIR.'sp-admin-bar-components.php');
     sp_AdminBarGetWaiting();
}

function sp_admin_bar_ahah_links() {
         include_once(SPABAHAHDIR.'sp-admin-bar-ahah-links.php');
}

function sp_admin_bar_ahah_update() {
         include_once(SPABAHAHDIR.'sp-admin-bar-ahah-update.php');
}

function sp_admin_bar_ahah_newposts() {
         include_once(SPABAHAHDIR.'sp-admin-bar-ahah-newposts.php');
}

function sp_admin_bar_ahah_quickreply() {
         include_once(SPABAHAHDIR.'sp-admin-bar-ahah-quickreply.php');
}

function sp_admin_bar_ahah_delspam() {
         include_once(SPABAHAHDIR.'sp-admin-bar-ahah-spam.php');
}

function sp_admin_bar_ahah_moderation() {
         include_once(SPABAHAHDIR.'sp-admin-bar-ahah-moderation.php');
}

function sp_admin_bar_dashboard() {
     include_once(SPABLIBDIR.'sp-admin-bar-components.php');
         sp_AdminBarDashboardPosts();
  }

function sp_admin_bar_create_post($add) {
         return true;
}

function sp_admin_bar_email($msg, $newpost) {
     include_once(SPABLIBDIR.'sp-admin-bar-components.php');
         $msg = sp_AdminBarEmail($msg, $newpost);
         return $msg;
}

function sp_admin_bar_new_post_list($newpostlist) {
     include_once(SPABLIBDIR.'sp-admin-bar-components.php');
         $newpostlist = sp_admin_bar_do_new_post_list($newpostlist);
     return $newpostlist;
  }

# Define Template Tags globally available (dont have to be enabled on template tag panel)
function sp_AdminQueue($args) {
     include_once(SPABTAGSDIR.'sp-admin-bar-queue-tag.php');
     sp_AdminQueueTag($args);
}

function sp_AdminLinks($args='', $label='', $toolTip='') {
     include_once(SPABTAGSDIR.'sp-admin-bar-links-tag.php');
     sp_AdminLinksTag($args, $label, $toolTip);
}

# ------------------------------------------------------
# Run Akismet against a post submission
# ------------------------------------------------------
function sp_run_akismet($newpost) {
         include_once(SPABLIBDIR.'sp-akismet.php');
         return sp_akismet($newpost);
}

?>
