<?php

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

# --------------------------------------------------------------------------------------
#
#       sp_AdminLinksTag()
#       Display the admin links
#       Scope:  site
#
#       class:                  CSS styling class
#
#       label:
#
# --------------------------------------------------------------------------------------
function sp_AdminLinksTag($args='', $label='', $toolTip='') {
         global $spThisUser;

         # bail if not admin or moderator
        if (!$spThisUser->admin) return;

         # is this admin showing the admin bar?
        if (!$spThisUser->sfadminbar) return;

         $defs = array('tagId'           => 'spAdminLinks',
                                   'tagClass'    => 'spAdminLinks',
                                   'icon'                => 'sp_AdminLinks.png',
                                   'iconClass'   => 'spAdminLinks'
                                   );
         $a = wp_parse_args($args, $defs);
         $a = apply_filters('sph_AdminLinks_args', $a);
         extract($a, EXTR_SKIP);

         # sanitize before use
        $tagId          = esc_attr($tagId);
         $tagClass       = esc_attr($tagClass);
         $icon           = sp_find_icon(SPABIMAGES, sanitize_file_name($icon));
         $iconClass      = esc_attr($iconClass);
         $toolTip        = esc_attr($toolTip);
         $label          = sp_filter_title_display($label);

         $site = SFHOMEURL."index.php?sp_ahah=admin-bar-links&amp;sfnonce=".wp_create_nonce('forum-ahah')."&amp;action=manage";
         $out = "<a class='$tagClass vtip' id='$tagId' title='$toolTip' rel='nofollow' href='javascript:void(null)' onclick='spjDialogAjax(this, \"$site\", \"$label\", 250, 0, 0);'>";
         if (!empty($icon)) $out.= "<img class='$iconClass' src='".$icon."' alt=''/>";
         if (!empty($label)) $out.= $label;
         $out.= "</a>\n";

         $out = apply_filters('sph_AdminLinks', $out, $a);
         echo $out;
}


?>
